# The different deployment types
TYPES=(DNA RNA-MS RNA-SS RNA-FM NonProd HTPD PVU FA RNA-MS-Star MSC-C MSC-Van MTC-Van Vantage)
# The different deployment types
BRANCHES=(develop main)
#Defining the folder for the csv file from which version will be used
BASE_PATH="C:\\HAMILTON\\Script\\Version"
#Defining the folder for the log file where logs will be created
LOG_File_Location="/c/Program Files (x86)/HAMILTON/Hamilton_Script_Log/Sync_Log.txt"
#Asking for first variable and assigning it in TYPE (RNA, DNA)
TYPE=$1
#Asking for second variable and assigning it in BRANCH (develop or main)
BRANCH=$2
#Asking for third variable and assigning it in SIMULATE (true or false)
SIMULATE=$3
#Defining the variable for later use
startURL=""
BRANCH_MATCH=0
TYPE_MATCH=0
# Checking if third input is empty, if it is empty then means we are updating the methods so just assign the value and echoing in file saying it is updating method. 
	if [ -z "$3" ]
	then
		SIMULATE="False";
		echo "**********************Start Updating repos on: $(date)***********************"$'\r' >> "$LOG_File_Location"
	else 
		echo "**********************Start Checking repos on: $(date)***********************"$'\r' >> "$LOG_File_Location"
	fi
for T in "${TYPES[@]}"; do
    if [[ $T = "$TYPE" ]]; then
        TYPE_MATCH=1
        break
    fi
done
for T in "${BRANCHES[@]}"; do
    if [[ $T = "$BRANCH" ]]; then
        BRANCH_MATCH=1
        break
    fi
done
if [ $TYPE_MATCH = 0 ] || [ $BRANCH_MATCH = 0 ]; then
    echo "!!!!!You must set a type: ${TYPES[@]}. You typed !!!!!"$TYPE""$'\r' >> "$LOG_File_Location"
	echo "!!!!!You must set a branch: ${BRANCHES[@]}. You typed !!!!!"$BRANCH""$'\r' >> "$LOG_File_Location"
	echo "**********************End due to improper values to variables: $(date)***********************"$'\r' >> "$LOG_File_Location"
    exit 1
fi
echo "Variable sets are Scale: "$TYPE" , Branch: "$BRANCH" "$'\r' >> "$LOG_File_Location"
# Change path to version folder, so it can update that folder
cd "$BASE_PATH"
# Try to make a bundle of any changes happen on this version locally and then delete it, so it is matching the last version on bitbucket
git stash && git stash drop
# Checking out the branch from local repo and then pull that particular branch from bitbucket to update it and printing the output of the command in the file.
git checkout $BRANCH && git pull origin $BRANCH 
# Capture the output of above process and store the value in success, if it is successful then value is 0 otherwise value is 128, if it is not success then print it in the file 					
success=$?
	if [ "$success" != "0" ]
	then 
		echo " Following Repo is $FULL_PATH is not able to update "$'\r' >> "$LOG_File_Location"
		# Changing color of the output test to red
		tput setaf 1;
		# Showing messages to user
		echo -n "Error while updating version File. Script will abort. Please contact IR";
		read ENTER <&2;
		# Aborting Script
		exit 1;	
	fi
# Reading CSV file and assigning vales in an array and then start a loop until it go through the whole array
cat version.csv | while IFS=, read -ra arr;
# start a loop
do
 # Assigning values from arrays into the variable which are easy to read and also removing any blank space or any next line character from the array value
	SCALE1=${arr[4]//[$'\r\n']}
	SCALE2=${arr[5]//[$'\r\n']}
	SCALE3=${arr[6]//[$'\r\n']}
	SCALE4=${arr[7]//[$'\r\n']}
	SCALE5=${arr[8]//[$'\r\n']}
	SCALE6=${arr[9]//[$'\r\n']}
	SCALE7=${arr[10]//[$'\r\n']}
	SCALE8=${arr[11]//[$'\r\n']}
	FULL_PATH=${arr[2]//[$'\r\n']}
	File_tag=${arr[3]//[$'\r\n']}
	CLONE_Path="$startURL${arr[1]}"
	Tem_BRANCH=${File_tag:0:1}
	arr1=($SCALE1 $SCALE2 $SCALE3 $SCALE4 $SCALE5 $SCALE6 $SCALE7 $SCALE8)
	for SCALE in "${arr1[@]}"
do
   # or do whatever with individual element of the array
# Checking What is the value of the scale because we only want to update particular branch and some common folders. And if it matches all or the variable provided. then it go in the loop otherwise it skip and check for next line
	if [[ "$SCALE" == "ALL" || "$SCALE" == "$TYPE" ]]	
	then
# Checking if the folder is present or not? IF not then go in else.	
		if [ -d "$FULL_PATH" ]
		then
# Change path to version folder, so it can update that folder		
			cd "$FULL_PATH"
# Get the File path of the folder for particular repo Get the current Tag version of the folder for particular repo			
			currentURL=$(git config --get remote.origin.url)
# Get the current Tag version of the folder for particular repo				
			currentTag=$(git describe --tags)
# Checking if the script need to update repos or just check that they are up to date or not			
			if [ "$SIMULATE" == "true" ]			
			then
# if checking then try to match the current tag of the folder to the tag in the file. if it is up to date then move on and if it is not then Abort the script and gave an message		
			if [ "$CLONE_Path" != "$currentURL" ]
				then
					echo " !!!!!Following Repo is $FULL_PATH is not correct repo!!!!!"$'\r' >> "$LOG_File_Location"
					exit 1
				else
					echo "up to date"
				fi	
				if [ "$currentTag" != "$File_tag" ]
				then
					echo " !!!!!Following Repo is $FULL_PATH not up to date or match csv file!!!!!"$'\r' >> "$LOG_File_Location"
					exit 1
				else
					echo "Correct Repo"
				fi
			else
				# Checking if Tem_BRANCH is M or D and based on that I am assigning the branch for the pull. 
				if [ "$Tem_BRANCH" == "M" ]
				then
					REPO_BRANCH="main"
				else 
					REPO_BRANCH="develop"
				fi
# Try to make a bundle of any changes happen on this version locally and then delete it, so it is matching the last version on bitbucket				
				git stash && git stash drop
# match the current tag of the folder to the tag in the file. if it is up to date then move on and if it is not then it fetches everything from bitbucket, then pull all the changes for the current branch and then checkout the tag which is in the file. 				
				
				if [ "$CLONE_Path" != "$currentURL" ]
				then
					echo " !!!!!Following Repo is $CLONE_Path is not correct repo!!!!!"$'\r' >> "$LOG_File_Location"
					cd ..
					rm -r "$FULL_PATH"
					echo "!!!!! Following Repo is $FULL_PATH is able to create!!!!!"$'\r' >> "$LOG_File_Location"
					git clone -b "$File_tag" "$CLONE_Path" "$FULL_PATH" 
				else
					echo "Correct Repo"
				fi
				if [ "$currentTag" != "$File_tag" ]
				then 
					git fetch && git pull origin $REPO_BRANCH && git checkout tags/"$File_tag"
# Capture the output of above process and store the value in success, if it is successful then value is 0 otherwise value is 128, if it is not success then print it in the file 				
					success=$?
					if [ "$success" != "0" ]
					then 
						echo "!!!!! Following Repo is $FULL_PATH is not able to update!!!!!"$'\r' >> "$LOG_File_Location"
						cd ..
						rm -r "$FULL_PATH"
						echo "!!!!! Following Repo is $FULL_PATH is able to create!!!!!"$'\r' >> "$LOG_File_Location"
						git clone -b "$File_tag" "$CLONE_Path" "$FULL_PATH" 
						
					else
						echo "$FULL_PATH is up to date at Tag $File_tag"$'\r' >> "$LOG_File_Location"
					fi
				else
					echo "$FULL_PATH is up to date at Tag $File_tag"$'\r' >> "$LOG_File_Location"
				fi
			fi	
		else
#If the folder does not exist then first it check if it is checking or updating. if checking then just abort the script and give an error
# if its updating then it clone that particular tag and make a copy in the folder which is mentioned in the csv file. 		
			if [ "$SIMULATE" == "true" ]
			then
				echo "Following Repo $FULL_PATH doesn't exist!"$'\r' >> "$LOG_File_Location"
				exit 1
			else
				git clone -b "$File_tag" "$CLONE_Path" "$FULL_PATH" 
# Capture the output of above process and store the value in success, if it is successful then value is 0 otherwise value is 128, if it is not success then print it in the file 					
				success=$?
					if [ "$success" != "0" ]
					then 
						echo "!!!!! Following Repo is $FULL_PATH is not able to create!!!!!"$'\r' >> "$LOG_File_Location"
						# Changing color of the output test to red
						tput setaf 1;
						# Showing messages to user
						echo -n "Error while updating $FULL_PATH. Script will abort. Please contact IR";
						read ENTER <&2;
						# Aborting Script
						exit 1;	
					fi
			fi
		fi
	fi
done
done
# checking the output of the while loop, to see if it work or break, if it break then it will be 1 and then we exit again with 1. 
[ $? == 1 ] && exit 1;
# copy the Liquid class file in from the git folder to the default folder in Hamilton Bin
cp "/c/HAMILTON/Liquid-Class/MasterLiquidClass.mdb" "/c/Program Files (x86)/HAMILTON/Config/ML_STARLiquids.mdb"
# echo that script is completed. 	
echo "********************** Completed script on: $(date)***********************"$'\r' >> "$LOG_File_Location"